
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef zone_ERROR_H
#define zone_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_zone    (3690)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_zone_NOT_IN_SPECIAL       H2_ENCODE_ERR(M_zone      , 1)
#define S_zone_NOT_IN_TARGET        H2_ENCODE_ERR(M_zone      , 2)
#define S_zone_NOT_IN_OBST          H2_ENCODE_ERR(M_zone      , 3)
#define S_zone_NOT_ENOUGH_MEMORY    H2_ENCODE_ERR(M_zone      , 4)
#define S_zone_NOT_READY            H2_ENCODE_ERR(M_zone      , 5)
#define S_zone_TOO_MANY_MOBILES     H2_ENCODE_ERR(M_zone      , 6)
#define S_zone_BAD_VALUE            H2_ENCODE_ERR(M_zone      , 7)
#define S_zone_CANNOT_OPEN_FILE     H2_ENCODE_ERR(M_zone      , 8)
#define S_zone_CANNOT_WRITE_POSTER  H2_ENCODE_ERR(M_zone      , 9)
#define S_zone_CANNOT_READ_FILE     H2_ENCODE_ERR(M_zone      , 10)
#define S_zone_CANNOT_READ_POSTER   H2_ENCODE_ERR(M_zone      , 11)
#define S_zone_NOT_CONNECTED_TO_POM H2_ENCODE_ERR(M_zone      , 12)


/* std errors */
#define S_zone_stdGenoM_ACTIVITY_INTERRUPTED       241886209   /* 3690<<16 | 0x8000 | 100<<8 | 1 */
#define S_zone_stdGenoM_TOO_MANY_ACTIVITIES        241886210   /* 3690<<16 | 0x8000 | 100<<8 | 2 */
#define S_zone_stdGenoM_ACTIVITY_FAILED            241886211   /* 3690<<16 | 0x8000 | 100<<8 | 3 */
#define S_zone_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 241886212   /* 3690<<16 | 0x8000 | 100<<8 | 4 */
#define S_zone_stdGenoM_UNKNOWN_ACTIVITY           241886213   /* 3690<<16 | 0x8000 | 100<<8 | 5 */
#define S_zone_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 241886214   /* 3690<<16 | 0x8000 | 100<<8 | 6 */
#define S_zone_stdGenoM_SYSTEM_ERROR               241886215   /* 3690<<16 | 0x8000 | 100<<8 | 7 */
#define S_zone_stdGenoM_ACTIVITY_ALREADY_ENDED     241886216   /* 3690<<16 | 0x8000 | 100<<8 | 8 */
#define S_zone_stdGenoM_WAIT_INIT_RQST             241886217   /* 3690<<16 | 0x8000 | 100<<8 | 9 */
#define S_zone_stdGenoM_CONTROL_CODEL_ERROR        241886218   /* 3690<<16 | 0x8000 | 100<<8 | 10 */
#define S_zone_stdGenoM_EXEC_TASK_SUSPENDED        241886219   /* 3690<<16 | 0x8000 | 100<<8 | 11 */
#define S_zone_stdGenoM_BAD_BLOCK_TYPE             241886220   /* 3690<<16 | 0x8000 | 100<<8 | 12 */
#define S_zone_stdGenoM_BAD_POSTER_TYPE            241886221   /* 3690<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define ZONE_H2_ERR_MSGS {\
    {"NOT_IN_SPECIAL", 1},\
    {"NOT_IN_TARGET", 2},\
    {"NOT_IN_OBST", 3},\
    {"NOT_ENOUGH_MEMORY", 4},\
    {"NOT_READY", 5},\
    {"TOO_MANY_MOBILES", 6},\
    {"BAD_VALUE", 7},\
    {"CANNOT_OPEN_FILE", 8},\
    {"CANNOT_WRITE_POSTER", 9},\
    {"CANNOT_READ_FILE", 10},\
    {"CANNOT_READ_POSTER", 11},\
    {"NOT_CONNECTED_TO_POM", 12},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int zoneRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
