
/* 
 * Copyright (c) 2003 LAAS/CNRS
 * Sara Fleury
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef ZONE_PRINTXML_H
#define ZONE_PRINTXML_H

#include "genom/printScan.h"
#include "genom/printXMLProto.h"

/* Structures definies par d'autres modules */

#include "server/sickPrintXML.h"

#include "server/seglocPrintXML.h"

#include "server/pomPrintXML.h"

#include "server/genBasicPrintXML.h"


#include "zonePosterLib.h"

/* Prototypes */
extern void printXML_struct_ZONE_NAVOBSTS_POSTER_STR ( FILE *out, char *name,
     struct ZONE_NAVOBSTS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_NAVMAP_POSTER_STR ( FILE *out, char *name,
     struct ZONE_NAVMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_VIRTUAL_OBSTROBOTIN_POSTER_STR ( FILE *out, char *name,
     struct ZONE_VIRTUAL_OBSTROBOTIN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_VIRTUAL_OBSTMAP_POSTER_STR ( FILE *out, char *name,
     struct ZONE_VIRTUAL_OBSTMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_SPECIALMOBILE3IN_POSTER_STR ( FILE *out, char *name,
     struct ZONE_SPECIALMOBILE3IN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_SPECIALMOBILE2IN_POSTER_STR ( FILE *out, char *name,
     struct ZONE_SPECIALMOBILE2IN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_SPECIALMOBILE1IN_POSTER_STR ( FILE *out, char *name,
     struct ZONE_SPECIALMOBILE1IN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_SPECIALROBOTIN_POSTER_STR ( FILE *out, char *name,
     struct ZONE_SPECIALROBOTIN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_SPECIALMAP_POSTER_STR ( FILE *out, char *name,
     struct ZONE_SPECIALMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_TARGETROBOTIN_POSTER_STR ( FILE *out, char *name,
     struct ZONE_TARGETROBOTIN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_TARGETMAP_POSTER_STR ( FILE *out, char *name,
     struct ZONE_TARGETMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_STR ( FILE *out, char *name,
     struct ZONE_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_GET_OUT_FROM_OBST ( FILE *out, char *name,
     struct ZONE_GET_OUT_FROM_OBST *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_OBSTS_IN_NAV_MAP ( FILE *out, char *name,
     struct ZONE_OBSTS_IN_NAV_MAP *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_OBSTS_IN_NAV_MAP_OBSTS ( FILE *out, char *name,
     struct ZONE_OBSTS_IN_NAV_MAP_OBSTS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_OBSTS_IN_NAV_MAP_HEADER ( FILE *out, char *name,
     struct ZONE_OBSTS_IN_NAV_MAP_HEADER *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ZONE_OBST_STATE ( FILE *out, char *name,
     enum ZONE_OBST_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_OBST ( FILE *out, char *name,
     struct ZONE_OBST *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ZONE_OBST_TYPE ( FILE *out, char *name,
     enum ZONE_OBST_TYPE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_OBSTS_FIELD ( FILE *out, char *name,
     struct ZONE_OBSTS_FIELD *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_TEST_OUTPUT ( FILE *out, char *name,
     struct ZONE_TEST_OUTPUT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_TEST_INPUT ( FILE *out, char *name,
     struct ZONE_TEST_INPUT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_MOBILE_AND_ZONE_TYPE ( FILE *out, char *name,
     struct ZONE_MOBILE_AND_ZONE_TYPE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_MOBILE_AND_ZONE_ID ( FILE *out, char *name,
     struct ZONE_MOBILE_AND_ZONE_ID *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_MOBILE_DESC ( FILE *out, char *name,
     struct ZONE_MOBILE_DESC *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_SEGLOC_MAP ( FILE *out, char *name,
     struct ZONE_SEGLOC_MAP *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ZONE_MAP_SOURCE ( FILE *out, char *name,
     enum ZONE_MAP_SOURCE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_ROBOT_TO_TARGET ( FILE *out, char *name,
     struct ZONE_ROBOT_TO_TARGET *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_PARAMS ( FILE *out, char *name,
     struct ZONE_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONES_MAP ( FILE *out, char *name,
     struct ZONES_MAP *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONES_OCCUPIED ( FILE *out, char *name,
     struct ZONES_OCCUPIED *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_IDENTITY ( FILE *out, char *name,
     struct ZONE_IDENTITY *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_DESC ( FILE *out, char *name,
     struct ZONE_DESC *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ZONE_STATE ( FILE *out, char *name,
     enum ZONE_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_FILE ( FILE *out, char *name,
     struct ZONE_FILE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ZONE_TYPE ( FILE *out, char *name,
     enum ZONE_TYPE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ZONE_MOBILE_ID ( FILE *out, char *name,
     enum ZONE_MOBILE_ID *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ZONE_CLASS ( FILE *out, char *name,
     enum ZONE_CLASS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_INIT ( FILE *out, char *name,
     struct ZONE_INIT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_ZONE_BOOL ( FILE *out, char *name,
     enum ZONE_BOOL *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_CONFIG ( FILE *out, char *name,
     struct ZONE_CONFIG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_ZONE_POINT ( FILE *out, char *name,
     struct ZONE_POINT *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void printXML_ZONE_POINT ( FILE *out, char *name,
     ZONE_POINT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_CONFIG ( FILE *out, char *name,
     ZONE_CONFIG *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_BOOL ( FILE *out, char *name,
     ZONE_BOOL *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_INIT ( FILE *out, char *name,
     ZONE_INIT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_CLASS ( FILE *out, char *name,
     ZONE_CLASS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_MOBILE_ID ( FILE *out, char *name,
     ZONE_MOBILE_ID *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_TYPE ( FILE *out, char *name,
     ZONE_TYPE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_FILE ( FILE *out, char *name,
     ZONE_FILE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_STATE ( FILE *out, char *name,
     ZONE_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_DESC ( FILE *out, char *name,
     ZONE_DESC *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_IDENTITY ( FILE *out, char *name,
     ZONE_IDENTITY *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONES_OCCUPIED ( FILE *out, char *name,
     ZONES_OCCUPIED *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONES_MAP ( FILE *out, char *name,
     ZONES_MAP *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_PARAMS ( FILE *out, char *name,
     ZONE_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_ROBOT_TO_TARGET ( FILE *out, char *name,
     ZONE_ROBOT_TO_TARGET *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_MAP_SOURCE ( FILE *out, char *name,
     ZONE_MAP_SOURCE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_SEGLOC_MAP ( FILE *out, char *name,
     ZONE_SEGLOC_MAP *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_MOBILE_DESC ( FILE *out, char *name,
     ZONE_MOBILE_DESC *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_MOBILE_AND_ZONE_ID ( FILE *out, char *name,
     ZONE_MOBILE_AND_ZONE_ID *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_MOBILE_AND_ZONE_TYPE ( FILE *out, char *name,
     ZONE_MOBILE_AND_ZONE_TYPE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_TEST_INPUT ( FILE *out, char *name,
     ZONE_TEST_INPUT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_TEST_OUTPUT ( FILE *out, char *name,
     ZONE_TEST_OUTPUT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_OBSTS_FIELD ( FILE *out, char *name,
     ZONE_OBSTS_FIELD *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_OBST_TYPE ( FILE *out, char *name,
     ZONE_OBST_TYPE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_OBST ( FILE *out, char *name,
     ZONE_OBST *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_OBST_STATE ( FILE *out, char *name,
     ZONE_OBST_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_OBSTS_IN_NAV_MAP_HEADER ( FILE *out, char *name,
     ZONE_OBSTS_IN_NAV_MAP_HEADER *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_OBSTS_IN_NAV_MAP_OBSTS ( FILE *out, char *name,
     ZONE_OBSTS_IN_NAV_MAP_OBSTS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_OBSTS_IN_NAV_MAP ( FILE *out, char *name,
     ZONE_OBSTS_IN_NAV_MAP *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_GET_OUT_FROM_OBST ( FILE *out, char *name,
     ZONE_GET_OUT_FROM_OBST *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_STR ( FILE *out, char *name,
     ZONE_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_TARGETMAP_POSTER_STR ( FILE *out, char *name,
     ZONE_TARGETMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_TARGETROBOTIN_POSTER_STR ( FILE *out, char *name,
     ZONE_TARGETROBOTIN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_SPECIALMAP_POSTER_STR ( FILE *out, char *name,
     ZONE_SPECIALMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_SPECIALROBOTIN_POSTER_STR ( FILE *out, char *name,
     ZONE_SPECIALROBOTIN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_SPECIALMOBILE1IN_POSTER_STR ( FILE *out, char *name,
     ZONE_SPECIALMOBILE1IN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_SPECIALMOBILE2IN_POSTER_STR ( FILE *out, char *name,
     ZONE_SPECIALMOBILE2IN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_SPECIALMOBILE3IN_POSTER_STR ( FILE *out, char *name,
     ZONE_SPECIALMOBILE3IN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_VIRTUAL_OBSTMAP_POSTER_STR ( FILE *out, char *name,
     ZONE_VIRTUAL_OBSTMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_VIRTUAL_OBSTROBOTIN_POSTER_STR ( FILE *out, char *name,
     ZONE_VIRTUAL_OBSTROBOTIN_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_NAVMAP_POSTER_STR ( FILE *out, char *name,
     ZONE_NAVMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_ZONE_NAVOBSTS_POSTER_STR ( FILE *out, char *name,
     ZONE_NAVOBSTS_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );

#endif /* ZONE_PRINT_XML_H */

