
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] zoneInstall] >= 0 } {
    interp expose {} zoneInstall
}

proc ::zoneInstall { name } {
    foreach rqst { "Start" "GetStartParams" "ReadZoneFile" "SaveZoneFile" "BuildNavMap" "SaveNavMap" "GetSeglocMap" "GetZoneById" "GetZoneByName" "MobileToMonitor" "RemoveMobile" "MonitorEnter" "MonitorLeave" "MonitorEnterZoneId" "MonitorLeaveZoneId" "Stop" "GetTargetDirection" "SimulPos" "GetZoneFile" "ExportObstsInNavZone" "StopExportObst" "MonitorObsts" "StopMonitorObsts" "GetOut" "GetCurrentTargetZone" "GetCurrentSpecialZone" "GetCurrentZones" "IsInZone" "TARGETMapZONES_MAPPosterRead" "TARGETRobotInZONES_OCCUPIEDPosterRead" "SPECIALMapZONES_MAPPosterRead" "SPECIALRobotInZONES_OCCUPIEDPosterRead" "SPECIALMobile1InZONES_OCCUPIEDPosterRead" "SPECIALMobile2InZONES_OCCUPIEDPosterRead" "SPECIALMobile3InZONES_OCCUPIEDPosterRead" "VIRTUAL_OBSTMapZONES_MAPPosterRead" "VIRTUAL_OBSTRobotInZONES_OCCUPIEDPosterRead" "NavMapMapPosterRead" "NavObstsHeaderPosterRead" "NavObstsObstaclesPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} zone$rqst $name
    }
}

interp hide {} zoneInstall




# Start ----------------------------------------------------------

if { [lsearch [interp hidden] zoneStart] >= 0 } {
    interp expose {} zoneStart
}
if { [lsearch [interp hidden] zoneStartFormatOutput] >= 0 } {
    interp expose {} zoneStartFormatOutput
}

proc ::zoneStart { name args } {
    set format {}
    lappend format [list float "Robot diameter in m" 5 ]
    lappend format [list { "ZONE_FALSE" "ZONE_TRUE" } "Simulation flag" "ZONE_FALSE" ]
    lappend format [list string "Name of the poster if not in simulmode" "pomPos" ]
    lappend format [list string "initParams.zonePathFiles.name" "" ]

    return [ ::cs::rqstSend "${name}" "Start" \
	"Start the monitoring from poster or simul mode (for ZONE_MOBILE_ROBOT, the mobile No 0), load the obstacles (can also be done later on with request ReadZoneFile), and set the value to enlarge or reduce obstacles (robotDiameter). WARNING: same value is used for all the mobiles." \
	"ZONE_INIT\n| float robotDiameter\n| ZONE_BOOL simulFlag\n| GEN_STRING64\n| | char name\[64\]\n| GEN_STRING128\n| | char name\[128\]\n" \
	4 \
	$format \
	$args ]
}


proc ::zoneStartFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneStart
interp hide {} zoneStartFormatOutput





# GetStartParams ----------------------------------------------------------

if { [lsearch [interp hidden] zoneGetStartParams] >= 0 } {
    interp expose {} zoneGetStartParams
}
if { [lsearch [interp hidden] zoneGetStartParamsFormatOutput] >= 0 } {
    interp expose {} zoneGetStartParamsFormatOutput
}

proc ::zoneGetStartParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetStartParams" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::zoneGetStartParamsFormatOutput { list } {
    set format { {} status { } { initParams { } robotDiameter { } simulFlag { } { posPosterName { } name } { } { zonePathFiles { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneGetStartParams
interp hide {} zoneGetStartParamsFormatOutput





# ReadZoneFile ----------------------------------------------------------

if { [lsearch [interp hidden] zoneReadZoneFile] >= 0 } {
    interp expose {} zoneReadZoneFile
}
if { [lsearch [interp hidden] zoneReadZoneFileFormatOutput] >= 0 } {
    interp expose {} zoneReadZoneFileFormatOutput
}

proc ::zoneReadZoneFile { name args } {
    set format {}
    lappend format [list { "ZONE_VIRTUAL_OBST" "ZONE_SPECIAL" "ZONE_TARGET" } "Zone types" "ZONE_VIRTUAL_OBST" ]
    lappend format [list int "unused" 0 ]
    lappend format [list string "Zone file path" "" ]

    return [ ::cs::rqstSend "${name}" "ReadZoneFile" \
	"** undocumented **" \
	"ZONE_FILE\n| ZONE_TYPE type\n| int unused\n| GEN_STRING128\n| | char name\[128\]\n" \
	3 \
	$format \
	$args ]
}


proc ::zoneReadZoneFileFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneReadZoneFile
interp hide {} zoneReadZoneFileFormatOutput





# SaveZoneFile ----------------------------------------------------------

if { [lsearch [interp hidden] zoneSaveZoneFile] >= 0 } {
    interp expose {} zoneSaveZoneFile
}
if { [lsearch [interp hidden] zoneSaveZoneFileFormatOutput] >= 0 } {
    interp expose {} zoneSaveZoneFileFormatOutput
}

proc ::zoneSaveZoneFile { name args } {
    set format {}
    lappend format [list { "ZONE_VIRTUAL_OBST" "ZONE_SPECIAL" "ZONE_TARGET" } "zoneType" "" ]

    return [ ::cs::rqstSend "${name}" "SaveZoneFile" \
	"** undocumented **" \
	"ZONE_TYPE zoneType\n" \
	1 \
	$format \
	$args ]
}


proc ::zoneSaveZoneFileFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneSaveZoneFile
interp hide {} zoneSaveZoneFileFormatOutput





# BuildNavMap ----------------------------------------------------------

if { [lsearch [interp hidden] zoneBuildNavMap] >= 0 } {
    interp expose {} zoneBuildNavMap
}
if { [lsearch [interp hidden] zoneBuildNavMapFormatOutput] >= 0 } {
    interp expose {} zoneBuildNavMapFormatOutput
}

proc ::zoneBuildNavMap { name args } {
    set format {}
    lappend format [list { "ZONE_FROM_FILE" "ZONE_FROM_POSTER" } "poster or file" "ZONE_FROM_POSTER" ]
    lappend format [list int "unused" 0 ]
    lappend format [list string "where to get segloc map" "seglocMap" ]

    return [ ::cs::rqstSend "${name}" "BuildNavMap" \
	"Computes nav map from segloc map and virt obst and exports it in NavMap poster. " \
	"ZONE_SEGLOC_MAP\n| ZONE_MAP_SOURCE source\n| int unused\n| GEN_STRING32\n| | char name\[32\]\n" \
	3 \
	$format \
	$args ]
}


proc ::zoneBuildNavMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneBuildNavMap
interp hide {} zoneBuildNavMapFormatOutput





# SaveNavMap ----------------------------------------------------------

if { [lsearch [interp hidden] zoneSaveNavMap] >= 0 } {
    interp expose {} zoneSaveNavMap
}
if { [lsearch [interp hidden] zoneSaveNavMapFormatOutput] >= 0 } {
    interp expose {} zoneSaveNavMapFormatOutput
}

proc ::zoneSaveNavMap { name args } {
    set format {}
    lappend format [list string "fileName.name" "" ]

    return [ ::cs::rqstSend "${name}" "SaveNavMap" \
	"Save nav map in a file" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::zoneSaveNavMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneSaveNavMap
interp hide {} zoneSaveNavMapFormatOutput





# GetSeglocMap ----------------------------------------------------------

if { [lsearch [interp hidden] zoneGetSeglocMap] >= 0 } {
    interp expose {} zoneGetSeglocMap
}
if { [lsearch [interp hidden] zoneGetSeglocMapFormatOutput] >= 0 } {
    interp expose {} zoneGetSeglocMapFormatOutput
}

proc ::zoneGetSeglocMap { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetSeglocMap" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::zoneGetSeglocMapFormatOutput { list } {
    set format { {} status { } { whereSeglocMap { } source { } unused { } { name { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneGetSeglocMap
interp hide {} zoneGetSeglocMapFormatOutput





# GetZoneById ----------------------------------------------------------

if { [lsearch [interp hidden] zoneGetZoneById] >= 0 } {
    interp expose {} zoneGetZoneById
}
if { [lsearch [interp hidden] zoneGetZoneByIdFormatOutput] >= 0 } {
    interp expose {} zoneGetZoneByIdFormatOutput
}

proc ::zoneGetZoneById { name args } {
    set format {}
    lappend format [list int "zoneId" 0 ]

    return [ ::cs::rqstSend "${name}" "GetZoneById" \
	"** undocumented **" \
	"int zoneId\n" \
	1 \
	$format \
	$args ]
}


proc ::zoneGetZoneByIdFormatOutput { list } {
    set format { {} status { } { zoneParams { } occupiedFlag { } nbPts { } firstPt { } lastPt { } { zoneDesc { } id { } class { } { name { } name } { } { finalPos { } x { } y { } theta } { } { target { } x { } y { } theta } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneGetZoneById
interp hide {} zoneGetZoneByIdFormatOutput





# GetZoneByName ----------------------------------------------------------

if { [lsearch [interp hidden] zoneGetZoneByName] >= 0 } {
    interp expose {} zoneGetZoneByName
}
if { [lsearch [interp hidden] zoneGetZoneByNameFormatOutput] >= 0 } {
    interp expose {} zoneGetZoneByNameFormatOutput
}

proc ::zoneGetZoneByName { name args } {
    set format {}
    lappend format [list string "zoneName.name" "" ]

    return [ ::cs::rqstSend "${name}" "GetZoneByName" \
	"** undocumented **" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::zoneGetZoneByNameFormatOutput { list } {
    set format { {} status { } { zoneParams { } occupiedFlag { } nbPts { } firstPt { } lastPt { } { zoneDesc { } id { } class { } { name { } name } { } { finalPos { } x { } y { } theta } { } { target { } x { } y { } theta } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneGetZoneByName
interp hide {} zoneGetZoneByNameFormatOutput





# MobileToMonitor ----------------------------------------------------------

if { [lsearch [interp hidden] zoneMobileToMonitor] >= 0 } {
    interp expose {} zoneMobileToMonitor
}
if { [lsearch [interp hidden] zoneMobileToMonitorFormatOutput] >= 0 } {
    interp expose {} zoneMobileToMonitorFormatOutput
}

proc ::zoneMobileToMonitor { name args } {
    set format {}
    for {set loop1(0) 0} { $loop1(0)<3 } { incr loop1(0)} {
    lappend format [list { "ZONE_FALSE" "ZONE_TRUE" } "Monitor zones TARGET" "ZONE_FALSE" ]
}
    lappend format [list int "Monitor zones SPECIAL" 1 ]
    lappend format [list string "Monitor zones VIRT OBST" 0 ]

    return [ ::cs::rqstSend "${name}" "MobileToMonitor" \
	"Monitor other mobile object" \
	"ZONE_MOBILE_DESC\n| ZONE_BOOL monitorZoneType\[3\]\n| int unused\n| GEN_STRING64\n| | char name\[64\]\n" \
	5 \
	$format \
	$args ]
}


proc ::zoneMobileToMonitorFormatOutput { list } {
    set format { {} status { } mobileId }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneMobileToMonitor
interp hide {} zoneMobileToMonitorFormatOutput





# RemoveMobile ----------------------------------------------------------

if { [lsearch [interp hidden] zoneRemoveMobile] >= 0 } {
    interp expose {} zoneRemoveMobile
}
if { [lsearch [interp hidden] zoneRemoveMobileFormatOutput] >= 0 } {
    interp expose {} zoneRemoveMobileFormatOutput
}

proc ::zoneRemoveMobile { name args } {
    set format {}
    lappend format [list { "ZONE_MOBILE_3" "ZONE_MOBILE_2" "ZONE_MOBILE_1" "ZONE_MOBILE_ROBOT" } "mobileId" "" ]

    return [ ::cs::rqstSend "${name}" "RemoveMobile" \
	"<some doc>" \
	"ZONE_MOBILE_ID mobileId\n" \
	1 \
	$format \
	$args ]
}


proc ::zoneRemoveMobileFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneRemoveMobile
interp hide {} zoneRemoveMobileFormatOutput





# MonitorEnter ----------------------------------------------------------

if { [lsearch [interp hidden] zoneMonitorEnter] >= 0 } {
    interp expose {} zoneMonitorEnter
}
if { [lsearch [interp hidden] zoneMonitorEnterFormatOutput] >= 0 } {
    interp expose {} zoneMonitorEnterFormatOutput
}

proc ::zoneMonitorEnter { name args } {
    set format {}
    lappend format [list { "ZONE_MOBILE_3" "ZONE_MOBILE_2" "ZONE_MOBILE_1" "ZONE_MOBILE_ROBOT" } "mobileId" "" ]

    return [ ::cs::rqstSend "${name}" "MonitorEnter" \
	"** undocumented **" \
	"ZONE_MOBILE_ID mobileId\n" \
	1 \
	$format \
	$args ]
}


proc ::zoneMonitorEnterFormatOutput { list } {
    set format { {} status { } { zoneIdentity { } mobileId { } unused { } id { } type { } { name { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneMonitorEnter
interp hide {} zoneMonitorEnterFormatOutput





# MonitorLeave ----------------------------------------------------------

if { [lsearch [interp hidden] zoneMonitorLeave] >= 0 } {
    interp expose {} zoneMonitorLeave
}
if { [lsearch [interp hidden] zoneMonitorLeaveFormatOutput] >= 0 } {
    interp expose {} zoneMonitorLeaveFormatOutput
}

proc ::zoneMonitorLeave { name args } {
    set format {}
    lappend format [list { "ZONE_MOBILE_3" "ZONE_MOBILE_2" "ZONE_MOBILE_1" "ZONE_MOBILE_ROBOT" } "mobileId" "" ]

    return [ ::cs::rqstSend "${name}" "MonitorLeave" \
	"** undocumented **" \
	"ZONE_MOBILE_ID mobileId\n" \
	1 \
	$format \
	$args ]
}


proc ::zoneMonitorLeaveFormatOutput { list } {
    set format { {} status { } { zoneIdentity { } mobileId { } unused { } id { } type { } { name { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneMonitorLeave
interp hide {} zoneMonitorLeaveFormatOutput





# MonitorEnterZoneId ----------------------------------------------------------

if { [lsearch [interp hidden] zoneMonitorEnterZoneId] >= 0 } {
    interp expose {} zoneMonitorEnterZoneId
}
if { [lsearch [interp hidden] zoneMonitorEnterZoneIdFormatOutput] >= 0 } {
    interp expose {} zoneMonitorEnterZoneIdFormatOutput
}

proc ::zoneMonitorEnterZoneId { name args } {
    set format {}
    lappend format [list { "ZONE_MOBILE_3" "ZONE_MOBILE_2" "ZONE_MOBILE_1" "ZONE_MOBILE_ROBOT" } "mobileAndZoneId.mobileId" "" ]
    lappend format [list int "mobileAndZoneId.zoneId" 0 ]

    return [ ::cs::rqstSend "${name}" "MonitorEnterZoneId" \
	"** undocumented **" \
	"ZONE_MOBILE_AND_ZONE_ID\n| ZONE_MOBILE_ID mobileId\n| int zoneId\n" \
	2 \
	$format \
	$args ]
}


proc ::zoneMonitorEnterZoneIdFormatOutput { list } {
    set format { {} status { } { zoneIdentity { } mobileId { } unused { } id { } type { } { name { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneMonitorEnterZoneId
interp hide {} zoneMonitorEnterZoneIdFormatOutput





# MonitorLeaveZoneId ----------------------------------------------------------

if { [lsearch [interp hidden] zoneMonitorLeaveZoneId] >= 0 } {
    interp expose {} zoneMonitorLeaveZoneId
}
if { [lsearch [interp hidden] zoneMonitorLeaveZoneIdFormatOutput] >= 0 } {
    interp expose {} zoneMonitorLeaveZoneIdFormatOutput
}

proc ::zoneMonitorLeaveZoneId { name args } {
    set format {}
    lappend format [list { "ZONE_MOBILE_3" "ZONE_MOBILE_2" "ZONE_MOBILE_1" "ZONE_MOBILE_ROBOT" } "mobileAndZoneId.mobileId" "" ]
    lappend format [list int "mobileAndZoneId.zoneId" 0 ]

    return [ ::cs::rqstSend "${name}" "MonitorLeaveZoneId" \
	"** undocumented **" \
	"ZONE_MOBILE_AND_ZONE_ID\n| ZONE_MOBILE_ID mobileId\n| int zoneId\n" \
	2 \
	$format \
	$args ]
}


proc ::zoneMonitorLeaveZoneIdFormatOutput { list } {
    set format { {} status { } { zoneIdentity { } mobileId { } unused { } id { } type { } { name { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneMonitorLeaveZoneId
interp hide {} zoneMonitorLeaveZoneIdFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] zoneStop] >= 0 } {
    interp expose {} zoneStop
}
if { [lsearch [interp hidden] zoneStopFormatOutput] >= 0 } {
    interp expose {} zoneStopFormatOutput
}

proc ::zoneStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::zoneStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneStop
interp hide {} zoneStopFormatOutput





# GetTargetDirection ----------------------------------------------------------

if { [lsearch [interp hidden] zoneGetTargetDirection] >= 0 } {
    interp expose {} zoneGetTargetDirection
}
if { [lsearch [interp hidden] zoneGetTargetDirectionFormatOutput] >= 0 } {
    interp expose {} zoneGetTargetDirectionFormatOutput
}

proc ::zoneGetTargetDirection { name args } {
    set format {}
    lappend format [list { "ZONE_MOBILE_3" "ZONE_MOBILE_2" "ZONE_MOBILE_1" "ZONE_MOBILE_ROBOT" } "mobileAndZoneId.mobileId" "" ]
    lappend format [list int "mobileAndZoneId.zoneId" 0 ]

    return [ ::cs::rqstSend "${name}" "GetTargetDirection" \
	"Get target direction for mobile No ZONE_MOBILE_ROBOT=0" \
	"ZONE_MOBILE_AND_ZONE_ID\n| ZONE_MOBILE_ID mobileId\n| int zoneId\n" \
	2 \
	$format \
	$args ]
}


proc ::zoneGetTargetDirectionFormatOutput { list } {
    set format { {} status { } { targetPos { } mobileId { } unused { } dist { } thetaRel { } thetaAbs } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneGetTargetDirection
interp hide {} zoneGetTargetDirectionFormatOutput





# SimulPos ----------------------------------------------------------

if { [lsearch [interp hidden] zoneSimulPos] >= 0 } {
    interp expose {} zoneSimulPos
}
if { [lsearch [interp hidden] zoneSimulPosFormatOutput] >= 0 } {
    interp expose {} zoneSimulPosFormatOutput
}

proc ::zoneSimulPos { name args } {
    set format {}
    lappend format [list double "simulPos.x" 0.0 ]
    lappend format [list double "simulPos.y" 0.0 ]
    lappend format [list double "simulPos.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SimulPos" \
	"Force the robot pos for test purpose" \
	"ZONE_CONFIG\n| double x\n| double y\n| double theta\n" \
	3 \
	$format \
	$args ]
}


proc ::zoneSimulPosFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneSimulPos
interp hide {} zoneSimulPosFormatOutput





# GetZoneFile ----------------------------------------------------------

if { [lsearch [interp hidden] zoneGetZoneFile] >= 0 } {
    interp expose {} zoneGetZoneFile
}
if { [lsearch [interp hidden] zoneGetZoneFileFormatOutput] >= 0 } {
    interp expose {} zoneGetZoneFileFormatOutput
}

proc ::zoneGetZoneFile { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetZoneFile" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::zoneGetZoneFileFormatOutput { list } {
    set format { {} status { } { fileName { } name } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneGetZoneFile
interp hide {} zoneGetZoneFileFormatOutput





# ExportObstsInNavZone ----------------------------------------------------------

if { [lsearch [interp hidden] zoneExportObstsInNavZone] >= 0 } {
    interp expose {} zoneExportObstsInNavZone
}
if { [lsearch [interp hidden] zoneExportObstsInNavZoneFormatOutput] >= 0 } {
    interp expose {} zoneExportObstsInNavZoneFormatOutput
}

proc ::zoneExportObstsInNavZone { name args } {
    set format {}
    lappend format [list double "max range" 2 ]
    lappend format [list double "direction of view in robot frame" 0 ]
    lappend format [list double "angular field of view" 2 ]

    return [ ::cs::rqstSend "${name}" "ExportObstsInNavZone" \
	"Exports in poster Obsts the segs given in poster input that are in nav zone (ie, not in virtual obst)" \
	"ZONE_OBSTS_FIELD\n| double range\n| double direction\n| double spreadAngle\n" \
	3 \
	$format \
	$args ]
}


proc ::zoneExportObstsInNavZoneFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneExportObstsInNavZone
interp hide {} zoneExportObstsInNavZoneFormatOutput





# StopExportObst ----------------------------------------------------------

if { [lsearch [interp hidden] zoneStopExportObst] >= 0 } {
    interp expose {} zoneStopExportObst
}
if { [lsearch [interp hidden] zoneStopExportObstFormatOutput] >= 0 } {
    interp expose {} zoneStopExportObstFormatOutput
}

proc ::zoneStopExportObst { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopExportObst" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::zoneStopExportObstFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneStopExportObst
interp hide {} zoneStopExportObstFormatOutput





# MonitorObsts ----------------------------------------------------------

if { [lsearch [interp hidden] zoneMonitorObsts] >= 0 } {
    interp expose {} zoneMonitorObsts
}
if { [lsearch [interp hidden] zoneMonitorObstsFormatOutput] >= 0 } {
    interp expose {} zoneMonitorObstsFormatOutput
}

proc ::zoneMonitorObsts { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "MonitorObsts" \
	"Monitors the dynamic obstacles density (ie, percentage of obstacles from sick that do not belong to virtual obstacles)" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::zoneMonitorObstsFormatOutput { list } {
    set format { {} status { } obstState }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneMonitorObsts
interp hide {} zoneMonitorObstsFormatOutput





# StopMonitorObsts ----------------------------------------------------------

if { [lsearch [interp hidden] zoneStopMonitorObsts] >= 0 } {
    interp expose {} zoneStopMonitorObsts
}
if { [lsearch [interp hidden] zoneStopMonitorObstsFormatOutput] >= 0 } {
    interp expose {} zoneStopMonitorObstsFormatOutput
}

proc ::zoneStopMonitorObsts { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopMonitorObsts" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::zoneStopMonitorObstsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneStopMonitorObsts
interp hide {} zoneStopMonitorObstsFormatOutput





# GetOut ----------------------------------------------------------

if { [lsearch [interp hidden] zoneGetOut] >= 0 } {
    interp expose {} zoneGetOut
}
if { [lsearch [interp hidden] zoneGetOutFormatOutput] >= 0 } {
    interp expose {} zoneGetOutFormatOutput
}

proc ::zoneGetOut { name args } {
    set format {}
    lappend format [list double "getOut.minDist" 0.0 ]
    lappend format [list double "getOut.pos.x" 0.0 ]
    lappend format [list double "getOut.pos.y" 0.0 ]

    return [ ::cs::rqstSend "${name}" "GetOut" \
	"If the position is within a virtual obstacle, computs the nearest segment of this obstacle and a position in the other side of this segment at the given distance." \
	"ZONE_GET_OUT_FROM_OBST\n| double minDist\n| ZONE_POINT\n| | double x\n| | double y\n" \
	3 \
	$format \
	$args ]
}


proc ::zoneGetOutFormatOutput { list } {
    set format { {} status { } { outPoint { } x { } y } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneGetOut
interp hide {} zoneGetOutFormatOutput





# GetCurrentTargetZone ----------------------------------------------------------

if { [lsearch [interp hidden] zoneGetCurrentTargetZone] >= 0 } {
    interp expose {} zoneGetCurrentTargetZone
}
if { [lsearch [interp hidden] zoneGetCurrentTargetZoneFormatOutput] >= 0 } {
    interp expose {} zoneGetCurrentTargetZoneFormatOutput
}

proc ::zoneGetCurrentTargetZone { name args } {
    set format {}
    lappend format [list { "ZONE_MOBILE_3" "ZONE_MOBILE_2" "ZONE_MOBILE_1" "ZONE_MOBILE_ROBOT" } "mobileAndZoneType.mobileId" "" ]
    lappend format [list { "ZONE_VIRTUAL_OBST" "ZONE_SPECIAL" "ZONE_TARGET" } "mobileAndZoneType.zoneType" "" ]

    return [ ::cs::rqstSend "${name}" "GetCurrentTargetZone" \
	"<some doc>" \
	"ZONE_MOBILE_AND_ZONE_TYPE\n| ZONE_MOBILE_ID mobileId\n| ZONE_TYPE zoneType\n" \
	2 \
	$format \
	$args ]
}


proc ::zoneGetCurrentTargetZoneFormatOutput { list } {
    set format { {} status { } { zoneIdentity { } mobileId { } unused { } id { } type { } { name { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneGetCurrentTargetZone
interp hide {} zoneGetCurrentTargetZoneFormatOutput





# GetCurrentSpecialZone ----------------------------------------------------------

if { [lsearch [interp hidden] zoneGetCurrentSpecialZone] >= 0 } {
    interp expose {} zoneGetCurrentSpecialZone
}
if { [lsearch [interp hidden] zoneGetCurrentSpecialZoneFormatOutput] >= 0 } {
    interp expose {} zoneGetCurrentSpecialZoneFormatOutput
}

proc ::zoneGetCurrentSpecialZone { name args } {
    set format {}
    lappend format [list { "ZONE_MOBILE_3" "ZONE_MOBILE_2" "ZONE_MOBILE_1" "ZONE_MOBILE_ROBOT" } "mobileAndZoneType.mobileId" "" ]
    lappend format [list { "ZONE_VIRTUAL_OBST" "ZONE_SPECIAL" "ZONE_TARGET" } "mobileAndZoneType.zoneType" "" ]

    return [ ::cs::rqstSend "${name}" "GetCurrentSpecialZone" \
	"<some doc>" \
	"ZONE_MOBILE_AND_ZONE_TYPE\n| ZONE_MOBILE_ID mobileId\n| ZONE_TYPE zoneType\n" \
	2 \
	$format \
	$args ]
}


proc ::zoneGetCurrentSpecialZoneFormatOutput { list } {
    set format { {} status { } { zoneIdentity { } mobileId { } unused { } id { } type { } { name { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneGetCurrentSpecialZone
interp hide {} zoneGetCurrentSpecialZoneFormatOutput





# GetCurrentZones ----------------------------------------------------------

if { [lsearch [interp hidden] zoneGetCurrentZones] >= 0 } {
    interp expose {} zoneGetCurrentZones
}
if { [lsearch [interp hidden] zoneGetCurrentZonesFormatOutput] >= 0 } {
    interp expose {} zoneGetCurrentZonesFormatOutput
}

proc ::zoneGetCurrentZones { name args } {
    set format {}
    lappend format [list { "ZONE_MOBILE_3" "ZONE_MOBILE_2" "ZONE_MOBILE_1" "ZONE_MOBILE_ROBOT" } "mobileAndZoneType.mobileId" "" ]
    lappend format [list { "ZONE_VIRTUAL_OBST" "ZONE_SPECIAL" "ZONE_TARGET" } "mobileAndZoneType.zoneType" "" ]

    return [ ::cs::rqstSend "${name}" "GetCurrentZones" \
	"<some doc>" \
	"ZONE_MOBILE_AND_ZONE_TYPE\n| ZONE_MOBILE_ID mobileId\n| ZONE_TYPE zoneType\n" \
	2 \
	$format \
	$args ]
}


proc ::zoneGetCurrentZonesFormatOutput { list } {
    set format { {} status { } { zoneIdentity { } mobileId { } unused { } id { } type { } { name { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneGetCurrentZones
interp hide {} zoneGetCurrentZonesFormatOutput





# IsInZone ----------------------------------------------------------

if { [lsearch [interp hidden] zoneIsInZone] >= 0 } {
    interp expose {} zoneIsInZone
}
if { [lsearch [interp hidden] zoneIsInZoneFormatOutput] >= 0 } {
    interp expose {} zoneIsInZoneFormatOutput
}

proc ::zoneIsInZone { name args } {
    set format {}
    lappend format [list { "ZONE_MOBILE_3" "ZONE_MOBILE_2" "ZONE_MOBILE_1" "ZONE_MOBILE_ROBOT" } "zoneIdentityInput.mobileId" "" ]
    lappend format [list int "zoneIdentityInput.unused" 0 ]
    lappend format [list int "zoneIdentityInput.zoneId" 0 ]
    lappend format [list { "ZONE_VIRTUAL_OBST" "ZONE_SPECIAL" "ZONE_TARGET" } "zoneIdentityInput.zoneType" "" ]
    lappend format [list string "zoneIdentityInput.zoneName.name" "" ]

    return [ ::cs::rqstSend "${name}" "IsInZone" \
	"<some doc>" \
	"ZONE_TEST_INPUT\n| ZONE_MOBILE_ID mobileId\n| int unused\n| int zoneId\n| ZONE_TYPE zoneType\n| GEN_STRING32\n| | char name\[32\]\n" \
	5 \
	$format \
	$args ]
}


proc ::zoneIsInZoneFormatOutput { list } {
    set format { {} status { } { res { } mobileId { } zoneTest } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneIsInZone
interp hide {} zoneIsInZoneFormatOutput





# TARGETMapZONES_MAP ----------------------------------------------------------

if { [lsearch [interp hidden] zoneTARGETMapZONES_MAPPosterRead] >= 0 } {
    interp expose {} zoneTARGETMapZONES_MAPPosterRead
}
if { [lsearch [interp hidden] zoneTARGETMapZONES_MAPPosterFormatOutput] >= 0 } {
    interp expose {} zoneTARGETMapZONES_MAPPosterFormatOutput
}

proc ::zoneTARGETMapZONES_MAPPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "TARGETMapZONES_MAP" \
	"ZONES_MAP\n| int nbZones\n| int nbTotalPoints\n| ZONE_DESC\n| | int id\n| | ZONE_CLASS class\n| | GEN_STRING32\n| | | char name\[32\]\n| | ZONE_CONFIG\n| | | double x\n| | | double y\n| | | double theta\n| | ZONE_CONFIG\n| | | double x\n| | | double y\n| | | double theta\n| int nbPtsPerZone\[40\]\n| ZONE_POINT\n| | double x\n| | double y\n" \
	$args ]
}


proc ::zoneTARGETMapZONES_MAPPosterFormatOutput { list } {
    set format { {} status { } { ZONES_MAP { } nbZones { } nbTotalPoints { 40 } { desc { } id { } class { } { name { } name } { } { finalPos { } x { } y { } theta } { } { target { } x { } y { } theta } } { 40 } nbPtsPerZone { 500 } { points { } x { } y } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneTARGETMapZONES_MAPPosterRead
interp hide {} zoneTARGETMapZONES_MAPPosterFormatOutput





# TARGETRobotInZONES_OCCUPIED ----------------------------------------------------------

if { [lsearch [interp hidden] zoneTARGETRobotInZONES_OCCUPIEDPosterRead] >= 0 } {
    interp expose {} zoneTARGETRobotInZONES_OCCUPIEDPosterRead
}
if { [lsearch [interp hidden] zoneTARGETRobotInZONES_OCCUPIEDPosterFormatOutput] >= 0 } {
    interp expose {} zoneTARGETRobotInZONES_OCCUPIEDPosterFormatOutput
}

proc ::zoneTARGETRobotInZONES_OCCUPIEDPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "TARGETRobotInZONES_OCCUPIED" \
	"ZONES_OCCUPIED\n| int nbZones\n| int nbOccupiedZones\n| ZONE_STATE occupiedFlag\[40\]\n| GEN_STRING32\n| | char name\[32\]\n" \
	$args ]
}


proc ::zoneTARGETRobotInZONES_OCCUPIEDPosterFormatOutput { list } {
    set format { {} status { } { ZONES_OCCUPIED { } nbZones { } nbOccupiedZones { 40 } occupiedFlag { 40 } { occupiedList { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneTARGETRobotInZONES_OCCUPIEDPosterRead
interp hide {} zoneTARGETRobotInZONES_OCCUPIEDPosterFormatOutput





# SPECIALMapZONES_MAP ----------------------------------------------------------

if { [lsearch [interp hidden] zoneSPECIALMapZONES_MAPPosterRead] >= 0 } {
    interp expose {} zoneSPECIALMapZONES_MAPPosterRead
}
if { [lsearch [interp hidden] zoneSPECIALMapZONES_MAPPosterFormatOutput] >= 0 } {
    interp expose {} zoneSPECIALMapZONES_MAPPosterFormatOutput
}

proc ::zoneSPECIALMapZONES_MAPPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SPECIALMapZONES_MAP" \
	"ZONES_MAP\n| int nbZones\n| int nbTotalPoints\n| ZONE_DESC\n| | int id\n| | ZONE_CLASS class\n| | GEN_STRING32\n| | | char name\[32\]\n| | ZONE_CONFIG\n| | | double x\n| | | double y\n| | | double theta\n| | ZONE_CONFIG\n| | | double x\n| | | double y\n| | | double theta\n| int nbPtsPerZone\[40\]\n| ZONE_POINT\n| | double x\n| | double y\n" \
	$args ]
}


proc ::zoneSPECIALMapZONES_MAPPosterFormatOutput { list } {
    set format { {} status { } { ZONES_MAP { } nbZones { } nbTotalPoints { 40 } { desc { } id { } class { } { name { } name } { } { finalPos { } x { } y { } theta } { } { target { } x { } y { } theta } } { 40 } nbPtsPerZone { 500 } { points { } x { } y } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneSPECIALMapZONES_MAPPosterRead
interp hide {} zoneSPECIALMapZONES_MAPPosterFormatOutput





# SPECIALRobotInZONES_OCCUPIED ----------------------------------------------------------

if { [lsearch [interp hidden] zoneSPECIALRobotInZONES_OCCUPIEDPosterRead] >= 0 } {
    interp expose {} zoneSPECIALRobotInZONES_OCCUPIEDPosterRead
}
if { [lsearch [interp hidden] zoneSPECIALRobotInZONES_OCCUPIEDPosterFormatOutput] >= 0 } {
    interp expose {} zoneSPECIALRobotInZONES_OCCUPIEDPosterFormatOutput
}

proc ::zoneSPECIALRobotInZONES_OCCUPIEDPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SPECIALRobotInZONES_OCCUPIED" \
	"ZONES_OCCUPIED\n| int nbZones\n| int nbOccupiedZones\n| ZONE_STATE occupiedFlag\[40\]\n| GEN_STRING32\n| | char name\[32\]\n" \
	$args ]
}


proc ::zoneSPECIALRobotInZONES_OCCUPIEDPosterFormatOutput { list } {
    set format { {} status { } { ZONES_OCCUPIED { } nbZones { } nbOccupiedZones { 40 } occupiedFlag { 40 } { occupiedList { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneSPECIALRobotInZONES_OCCUPIEDPosterRead
interp hide {} zoneSPECIALRobotInZONES_OCCUPIEDPosterFormatOutput





# SPECIALMobile1InZONES_OCCUPIED ----------------------------------------------------------

if { [lsearch [interp hidden] zoneSPECIALMobile1InZONES_OCCUPIEDPosterRead] >= 0 } {
    interp expose {} zoneSPECIALMobile1InZONES_OCCUPIEDPosterRead
}
if { [lsearch [interp hidden] zoneSPECIALMobile1InZONES_OCCUPIEDPosterFormatOutput] >= 0 } {
    interp expose {} zoneSPECIALMobile1InZONES_OCCUPIEDPosterFormatOutput
}

proc ::zoneSPECIALMobile1InZONES_OCCUPIEDPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SPECIALMobile1InZONES_OCCUPIED" \
	"ZONES_OCCUPIED\n| int nbZones\n| int nbOccupiedZones\n| ZONE_STATE occupiedFlag\[40\]\n| GEN_STRING32\n| | char name\[32\]\n" \
	$args ]
}


proc ::zoneSPECIALMobile1InZONES_OCCUPIEDPosterFormatOutput { list } {
    set format { {} status { } { ZONES_OCCUPIED { } nbZones { } nbOccupiedZones { 40 } occupiedFlag { 40 } { occupiedList { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneSPECIALMobile1InZONES_OCCUPIEDPosterRead
interp hide {} zoneSPECIALMobile1InZONES_OCCUPIEDPosterFormatOutput





# SPECIALMobile2InZONES_OCCUPIED ----------------------------------------------------------

if { [lsearch [interp hidden] zoneSPECIALMobile2InZONES_OCCUPIEDPosterRead] >= 0 } {
    interp expose {} zoneSPECIALMobile2InZONES_OCCUPIEDPosterRead
}
if { [lsearch [interp hidden] zoneSPECIALMobile2InZONES_OCCUPIEDPosterFormatOutput] >= 0 } {
    interp expose {} zoneSPECIALMobile2InZONES_OCCUPIEDPosterFormatOutput
}

proc ::zoneSPECIALMobile2InZONES_OCCUPIEDPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SPECIALMobile2InZONES_OCCUPIED" \
	"ZONES_OCCUPIED\n| int nbZones\n| int nbOccupiedZones\n| ZONE_STATE occupiedFlag\[40\]\n| GEN_STRING32\n| | char name\[32\]\n" \
	$args ]
}


proc ::zoneSPECIALMobile2InZONES_OCCUPIEDPosterFormatOutput { list } {
    set format { {} status { } { ZONES_OCCUPIED { } nbZones { } nbOccupiedZones { 40 } occupiedFlag { 40 } { occupiedList { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneSPECIALMobile2InZONES_OCCUPIEDPosterRead
interp hide {} zoneSPECIALMobile2InZONES_OCCUPIEDPosterFormatOutput





# SPECIALMobile3InZONES_OCCUPIED ----------------------------------------------------------

if { [lsearch [interp hidden] zoneSPECIALMobile3InZONES_OCCUPIEDPosterRead] >= 0 } {
    interp expose {} zoneSPECIALMobile3InZONES_OCCUPIEDPosterRead
}
if { [lsearch [interp hidden] zoneSPECIALMobile3InZONES_OCCUPIEDPosterFormatOutput] >= 0 } {
    interp expose {} zoneSPECIALMobile3InZONES_OCCUPIEDPosterFormatOutput
}

proc ::zoneSPECIALMobile3InZONES_OCCUPIEDPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SPECIALMobile3InZONES_OCCUPIED" \
	"ZONES_OCCUPIED\n| int nbZones\n| int nbOccupiedZones\n| ZONE_STATE occupiedFlag\[40\]\n| GEN_STRING32\n| | char name\[32\]\n" \
	$args ]
}


proc ::zoneSPECIALMobile3InZONES_OCCUPIEDPosterFormatOutput { list } {
    set format { {} status { } { ZONES_OCCUPIED { } nbZones { } nbOccupiedZones { 40 } occupiedFlag { 40 } { occupiedList { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneSPECIALMobile3InZONES_OCCUPIEDPosterRead
interp hide {} zoneSPECIALMobile3InZONES_OCCUPIEDPosterFormatOutput





# VIRTUAL_OBSTMapZONES_MAP ----------------------------------------------------------

if { [lsearch [interp hidden] zoneVIRTUAL_OBSTMapZONES_MAPPosterRead] >= 0 } {
    interp expose {} zoneVIRTUAL_OBSTMapZONES_MAPPosterRead
}
if { [lsearch [interp hidden] zoneVIRTUAL_OBSTMapZONES_MAPPosterFormatOutput] >= 0 } {
    interp expose {} zoneVIRTUAL_OBSTMapZONES_MAPPosterFormatOutput
}

proc ::zoneVIRTUAL_OBSTMapZONES_MAPPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "VIRTUAL_OBSTMapZONES_MAP" \
	"ZONES_MAP\n| int nbZones\n| int nbTotalPoints\n| ZONE_DESC\n| | int id\n| | ZONE_CLASS class\n| | GEN_STRING32\n| | | char name\[32\]\n| | ZONE_CONFIG\n| | | double x\n| | | double y\n| | | double theta\n| | ZONE_CONFIG\n| | | double x\n| | | double y\n| | | double theta\n| int nbPtsPerZone\[40\]\n| ZONE_POINT\n| | double x\n| | double y\n" \
	$args ]
}


proc ::zoneVIRTUAL_OBSTMapZONES_MAPPosterFormatOutput { list } {
    set format { {} status { } { ZONES_MAP { } nbZones { } nbTotalPoints { 40 } { desc { } id { } class { } { name { } name } { } { finalPos { } x { } y { } theta } { } { target { } x { } y { } theta } } { 40 } nbPtsPerZone { 500 } { points { } x { } y } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneVIRTUAL_OBSTMapZONES_MAPPosterRead
interp hide {} zoneVIRTUAL_OBSTMapZONES_MAPPosterFormatOutput





# VIRTUAL_OBSTRobotInZONES_OCCUPIED ----------------------------------------------------------

if { [lsearch [interp hidden] zoneVIRTUAL_OBSTRobotInZONES_OCCUPIEDPosterRead] >= 0 } {
    interp expose {} zoneVIRTUAL_OBSTRobotInZONES_OCCUPIEDPosterRead
}
if { [lsearch [interp hidden] zoneVIRTUAL_OBSTRobotInZONES_OCCUPIEDPosterFormatOutput] >= 0 } {
    interp expose {} zoneVIRTUAL_OBSTRobotInZONES_OCCUPIEDPosterFormatOutput
}

proc ::zoneVIRTUAL_OBSTRobotInZONES_OCCUPIEDPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "VIRTUAL_OBSTRobotInZONES_OCCUPIED" \
	"ZONES_OCCUPIED\n| int nbZones\n| int nbOccupiedZones\n| ZONE_STATE occupiedFlag\[40\]\n| GEN_STRING32\n| | char name\[32\]\n" \
	$args ]
}


proc ::zoneVIRTUAL_OBSTRobotInZONES_OCCUPIEDPosterFormatOutput { list } {
    set format { {} status { } { ZONES_OCCUPIED { } nbZones { } nbOccupiedZones { 40 } occupiedFlag { 40 } { occupiedList { } name } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneVIRTUAL_OBSTRobotInZONES_OCCUPIEDPosterRead
interp hide {} zoneVIRTUAL_OBSTRobotInZONES_OCCUPIEDPosterFormatOutput





# NavMapMap ----------------------------------------------------------

if { [lsearch [interp hidden] zoneNavMapMapPosterRead] >= 0 } {
    interp expose {} zoneNavMapMapPosterRead
}
if { [lsearch [interp hidden] zoneNavMapMapPosterFormatOutput] >= 0 } {
    interp expose {} zoneNavMapMapPosterFormatOutput
}

proc ::zoneNavMapMapPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "NavMapMap" \
	"SEGLOC_MAP\n| SEGLOC_MAP_HEADER\n| | int nbSegs\n| | int mapNum\n| | SEGLOC_POS\n| | | double x\n| | | double y\n| | | double theta\n| | char envName\[64\]\n| SEGLOC_SEG\n| | double x1\n| | double y1\n| | double x2\n| | double y2\n" \
	$args ]
}


proc ::zoneNavMapMapPosterFormatOutput { list } {
    set format { {} status { } { Map { } { header { } nbSegs { } mapNum { } { pos { } x { } y { } theta } { } envName } { 1000 } { segs { } x1 { } y1 { } x2 { } y2 } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneNavMapMapPosterRead
interp hide {} zoneNavMapMapPosterFormatOutput





# NavObstsHeader ----------------------------------------------------------

if { [lsearch [interp hidden] zoneNavObstsHeaderPosterRead] >= 0 } {
    interp expose {} zoneNavObstsHeaderPosterRead
}
if { [lsearch [interp hidden] zoneNavObstsHeaderPosterFormatOutput] >= 0 } {
    interp expose {} zoneNavObstsHeaderPosterFormatOutput
}

proc ::zoneNavObstsHeaderPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "NavObstsHeader" \
	"ZONE_OBSTS_IN_NAV_MAP_HEADER\n| ZONE_OBST_STATE obstState\n| int id\n| int nbObsts\n| int nbDynObsts\n| int nbFreeWays\n| int unused\n| double obstsLengthSumCart\n| double freeWaysLengthSumCart\n| double theoricalFreeWaysLengthSumCart\n| double obstsLengthSumPolar\n| double freeWaysLengthSumPolar\n| double theoricalFreeWaysLengthSumPolar\n| int clutteredPercentCart\n| int clutteredPercentPolar\n| ZONE_OBSTS_FIELD\n| | double range\n| | double direction\n| | double spreadAngle\n" \
	$args ]
}


proc ::zoneNavObstsHeaderPosterFormatOutput { list } {
    set format { {} status { } { Header { } obstState { } id { } nbObsts { } nbDynObsts { } nbFreeWays { } unused { } obstsLengthSumCart { } freeWaysLengthSumCart { } theoricalFreeWaysLengthSumCart { } obstsLengthSumPolar { } freeWaysLengthSumPolar { } theoricalFreeWaysLengthSumPolar { } clutteredPercentCart { } clutteredPercentPolar { } { obstsField { } range { } direction { } spreadAngle } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneNavObstsHeaderPosterRead
interp hide {} zoneNavObstsHeaderPosterFormatOutput





# NavObstsObstacles ----------------------------------------------------------

if { [lsearch [interp hidden] zoneNavObstsObstaclesPosterRead] >= 0 } {
    interp expose {} zoneNavObstsObstaclesPosterRead
}
if { [lsearch [interp hidden] zoneNavObstsObstaclesPosterFormatOutput] >= 0 } {
    interp expose {} zoneNavObstsObstaclesPosterFormatOutput
}

proc ::zoneNavObstsObstaclesPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "NavObstsObstacles" \
	"ZONE_OBSTS_IN_NAV_MAP_OBSTS\n| ZONE_OBST\n| | ZONE_OBST_TYPE type\n| | int unused\n| | double distMin\n| | double angleMean\n| | double width\n" \
	$args ]
}


proc ::zoneNavObstsObstaclesPosterFormatOutput { list } {
    set format { {} status { } { Obstacles { 20 } { obst { } type { } unused { } distMin { } angleMean { } width } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} zoneNavObstsObstaclesPosterRead
interp hide {} zoneNavObstsObstaclesPosterFormatOutput


